#LyX 1.3 created this file. For more info see http://www.lyx.org/
\lyxformat 221
\textclass book
\language english
\inputencoding auto
\fontscheme default
\graphics default
\paperfontsize default
\spacing single 
\papersize Default
\paperpackage a4
\use_geometry 0
\use_amsmath 0
\use_natbib 0
\use_numerical_citations 0
\paperorientation portrait
\secnumdepth 3
\tocdepth 3
\paragraph_separation indent
\defskip medskip
\quotes_language english
\quotes_times 2
\papercolumns 1
\papersides 1
\paperpagestyle default

\layout Section

Lestes Structures Generator
\layout Standard

The goal of the generator is to allow easy maintenance of complex data structure
s used at different compilation levels.
 It embraces hundreds of classes with some common parts, which can be generated
 automatically.
 Support for garbage collection, dumping, visitors etc.
 becomes nearly transparent this way.
\layout Standard

The generator is written in the 
\begin_inset LatexCommand \htmlurl[XSL Transformations language]{http://www.w3.org/TR/xslt}

\end_inset 

 (XSLT) and takes 
\begin_inset LatexCommand \htmlurl[XML]{http://www.w3.org/XML/}

\end_inset 

 files as input.
 Result is as C++ code.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-formats}

\end_inset 

Data formats and processing
\layout Standard

There are two types the of source XML files: Lestes Structures Description
 (LSD, stored in *.lsd files) and Lestes Visitors Description (LVD in *.lvd
 files).
 LSD is used to describe several classes, their members, inheritance and
 special properties.
 LVD is used by the visitors-generating mechanism, see the Visitors 
\begin_inset LatexCommand \ref{sub:lsg-visitors}

\end_inset 

 section below.
\layout Standard

To process LSD and LVD files a XSLT processor is needed, such as 
\series bold 
xsltproc
\series default 
 [link].
 The process is fully supported by our build system [link].
\layout Standard

There are several stylesheets (*.xslt) in 
\series bold 
util/lsg
\series default 
 directory, but the most important are 
\series bold 
lsd2hh
\series default 
, 
\series bold 
lsd2cc
\series default 
, 
\series bold 
lvd2lsd
\series default 
, and 
\series bold 
lvd2cc
\series default 
.
 The lsd2* take an X.lsd file as input and create one X.g.cc and one X.g.hh file
 (g as 
\begin_inset Quotes eld
\end_inset 

generated
\begin_inset Quotes erd
\end_inset 

).
 If there are some methods to be implemented by hand, it should be placed
 in hand-written X.cc file.
 lvd2* stylesheets take a LVD file to generate Y.v.lsd and Y.v.cc (v as 
\begin_inset Quotes eld
\end_inset 

visitors
\begin_inset Quotes erd
\end_inset 

), see the Visitors 
\begin_inset LatexCommand \ref{sub:lsg-visitors}

\end_inset 

 section below.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-validation}

\end_inset 

XML validation
\layout Standard

Validating a file as a correct LSD or LVD file is not possible at this time.
 A 
\begin_inset LatexCommand \url[XML Schema]{http://www.w3.org/XML/Schema}

\end_inset 

 for LSD and LVD should be written ASAP.
 The generator itself does no sort of checking and if a bug appears in an
 input file, the generated code may be wrong or the XSLT processor may fall
 down.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-comments}

\end_inset 

Comments
\layout Standard

Anywhere in LSD or LVD file a <comment> element may occur.
 Its content is ignored by generator.
 An alternative is a XML-like comment:
\layout LyX-Code

<!-- This text is ignored by XML parser.
 -->
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-lsdheader}

\end_inset 

LSD file header
\layout Subsubsection

Root element and XML namespaces
\layout Standard

It is recommended to watch 
\series bold 
util/lsg/example.lsd
\series default 
 and other examples in the directory along with creating LSD files.
 The first two lines and root element name are common for all LSD files.
\layout LyX-Code

<?xml version="1.0" encoding="UTF-8"?>
\layout LyX-Code

<lsd xmlns="http://lestes.jikos.cz/schemas/lsd" xmlns:h="http://www.w3.org/TR/REC-ht
ml40">
\layout LyX-Code

...
\layout LyX-Code

</lsd>
\layout Standard

The 
\series bold 
xmlns:h
\series default 
 attribute can be omitted if we do not use HTML tags in Doxygen comments
 
\begin_inset LatexCommand \ref{sub:lsg-doxygen}

\end_inset 

.
\layout Subsubsection

LSD prolog
\layout Standard

The header part of LSD contains the following elements in this order:
\layout LyX-Code

<dox/>
\layout LyX-Code

<file-name/>
\layout LyX-Code

<packages/>
\layout LyX-Code

<imports/>
\layout LyX-Code

<implementation-imports/>
\layout LyX-Code

<hh-header/>
\layout LyX-Code

<hh-footer/>
\layout LyX-Code

<cc-header/>
\layout LyX-Code

<cc-footer/>
\layout LyX-Code

<include/>
\layout LyX-Code

<default-base/>
\layout LyX-Code

<default-collection/>
\layout LyX-Code

<default-check/>
\layout Standard

Any of these elements may be omitted or left empty if we don't need it.
 Only the <file-name> element is required and contains the name of the LSD
 file without extension.
 It must not contain any peculiar characters because it's used as a part
 of an identifier in output C++ code.
 Dashes and dots are allowed.
\layout Standard

The <dox> part contains <bri> and <det> elements, which store a doxygen
 documentation for files generated from this LSD (brief and detailed).
 There may be two <dox> elements with 
\series bold 
file="hh"
\series default 
 and 
\series bold 
file="cc"
\series default 
 attributes, or only one with 
\series bold 
file="both"
\series default 
.
 The attribute says whether the documentation describes only the header
 or implementation file or both.
 See also the Doxygen 
\begin_inset LatexCommand \ref{sub:lsg-doxygen}

\end_inset 

 section below.
\layout Standard

The <imports> element contain any number of <i> elements, each of them containin
g a path to a file.
 Such <i> element corresponds to one 
\series bold 
#include
\series default 
 line in output *.g.hh header file.
 The file name is always bounded by < and > brackets, because relative including
 with quotes is prohibited in Lestes project.
\layout Standard

The <implementation-imports> part is analogous to the previous one, but
 the 
\series bold 
#include
\series default 
 lines are generated only into *.g.cc implementation file instead of the header
 file.
\layout Standard

The <packages> element is to satisfy the namespace policy in Lestes project.
 It contains package names in <p> elements.
 All classes generated from this file are placed into one namespace determined
 by these package names.
 See also the Napespaces section 
\begin_inset LatexCommand \ref{sub:lsg-namespaces}

\end_inset 

 below.
\layout Standard

The following elements:
\layout LyX-Code

<hh-header/>
\layout LyX-Code

<hh-footer/>
\layout LyX-Code

<cc-header/>
\layout LyX-Code

<cc-footer/>
\layout Standard

may be used to add a few hand-written code into the generated C++ files.
\layout Standard

The <include> element may occur arbitrarily many times and has one required
 attribute - 
\series bold 
href
\series default 
.
 It contains a path to another LSD file.
 It's purpose isn't a true inclusion such as in C++.
 The only purpose of these links is to make other generated classes in the
 same namespace visible for generator, if they are bases of hereby classes.
 A generated constructor or factory method 
\begin_inset LatexCommand \ref{sub:lsg-instance}

\end_inset 

 must initialize all data members of current class, including the inherited
 ones.
 Therefore parents must be accessible for generator.
 Note that the search for bases is done recursively, so you should include
 only the LSD file with the nearest descendant.
 The cycling in inclusion is not treated, so users must avoid it.
 And it is also bad if some class can be reached more than one way via includes.
 However it is easy to obey these restrictions if the <include> hierarchy
 is a tree corresponding to the natural ISA hierarchy between classes.
\layout Standard

The <default-base> element has a 
\series bold 
type
\series default 
 attribute.
 It denotes a base class for all classes with the 
\series bold 
base
\series default 
 attribute omitted.
\layout Standard

The <default-collection> element has a 
\series bold 
kind
\series default 
 attribute.
 It denotes a kind for all collection members with 
\series bold 
kind
\series default 
 attribute omitted.
\layout Standard

The <default-check> element may contain a name of a macro to be used as
 default for this LSD file instead of 
\series bold 
checked(arg)
\series default 
.
 Function of this macro is described 
\begin_inset LatexCommand \label{sub:lsg-instance}

\end_inset 

 below.
\layout Standard

Some helper declarations follow the header part: <forward-class>, <using-class>,
 and <foreign-class>.
 Their usage is described below in sections Garbage collection 
\begin_inset LatexCommand \ref{sub:lsg-garbage}

\end_inset 

, Namespaces 
\begin_inset LatexCommand \ref{sub:lsg-namespaces}

\end_inset 

, and 
\begin_inset LatexCommand \ref{sub:lsg-faq}

\end_inset 

.
\layout Standard

The main part of an LSD file contains declarations of classes, enumerations,
 and types.
\layout Subsection

Class description
\layout Standard

Ordering of classes may be nearly arbitrary, since a forward declaration
 is generated for each <class>.
 The only rule is that the base class must precede it's children.
\layout Standard

Element <class> has the following attributes:
\layout Itemize


\series bold 
name
\series default 
 (required): An identifier for the class.
\layout Itemize


\series bold 
base
\series default 
: Name of a base class.
 Can be omitted if a default base is declared in header part of the document.
 Multiple and virtual inheritance is not supported.
\layout Itemize


\series bold 
abstract
\series default 
: Contains "yes" or "no", default is "no".
 Abstract classes can't be instantiated and lack factory methods.
 A class containing an abstract method must be explicitly marked as abstract.
\layout Standard

Element <class> may have the following content:
\layout Itemize

<field>: Describes a data member.
 Visibility of each data member is private.
 set(), get(), and alt() methods are public.
 <field> attributes are:
\begin_deeper 
\layout Itemize


\series bold 
name
\series default 
 (required): Field identifier.
\layout Itemize


\series bold 
type
\series default 
 (required): Data type.
 If the member is a class, there should be simply the identifier of the
 class.
 The generator will automatically create a smart pointer and operate with
 it.
 See also Garbage collection 
\begin_inset LatexCommand \ref{sub:lsg-garbage}

\end_inset 

 below.
\layout Itemize


\series bold 
set
\series default 
: May contain "special", "none", or "".
 Default is "".
 By default, the set() method is generated and trivially returns the field
 value.
 "none" means that the member lacks set() method.
 And "special" means that the set() method is present but hand-written.
 See also Class data access 
\begin_inset LatexCommand \ref{sub:lsg-dataaccess}

\end_inset 

.
\layout Itemize


\series bold 
get
\series default 
: Describes the get() method in analogy to set().
\layout Itemize


\series bold 
alt
\series default 
: Describes the alt() method in analogy to set().
\layout Itemize


\series bold 
specifier
\series default 
: Contains a specifier for the field, allowed values are "static" or "",
 default is "".
 A static member is treated specially as C++ requires.
 (It's declaration is placed to the bottom of .g.cc file.) The 
\series bold 
init
\series default 
 attribute works well with this.
\layout Itemize


\series bold 
init
\series default 
: Contains an initializer for the field.
 May contain simply a value or "" or "void", default is "void".
 "void" means that the member is always initialized through a parameter
 of a factory method.
 Otherwise, the attribute value is used as an initializer.
 See also Creating an instance 
\begin_inset LatexCommand \ref{sub:lsg-instance}

\end_inset 

.
\layout Itemize


\series bold 
check
\series default 
: Value of each field is assertion-checked with a special macro before class
 construction (see 
\begin_inset LatexCommand \ref{sub:lsg-instance}

\end_inset 

).
 The default name of the macro is "checked" or may be specified in <default-chec
k/> element (in LSD header part 
\begin_inset LatexCommand \ref{sub:lsg-lsdheader}

\end_inset 

).
 Setting the 
\series bold 
check
\series default 
 attribute to a field allows you to call a different macro.
\end_deeper 
\layout Itemize

<collection>: Describes a collection of values, similarly to the <field>
 element, using the same attributes.
 One difference is in the 
\series bold 
init
\series default 
 attribute, which is restricted to two cases.
 1) Missing 
\series bold 
init
\series default 
 or "void" means a collection initialized by a factory method parameter.
 2) 
\series bold 
init
\series default 
="" means initialization as an empty collection.
 Attribute 
\series bold 
kind
\series default 
 may be "list", "vector", "set", or "map".
 It's default value is specified in <default-collection> top-level element.
 Lestes STL wrappers [link] are always used to ensure garbage collection
 [link].
 The 
\series bold 
map
\series default 
 collection has two additional attributes:
\begin_deeper 
\layout Itemize


\series bold 
key
\series default 
 (required): Contains a data type used as a key in the map.
\layout Itemize


\series bold 
comparator
\series default 
: Describes a special comparator for the keys.
 For example: 
\series bold 
comparator="::std::greater&lt;int&gt;"
\end_deeper 
\layout Itemize

<method>: Describes a method that will be written by hand.
 The attributes are:
\begin_deeper 
\layout Itemize


\series bold 
name
\series default 
 (required): Method identifier.
\layout Itemize


\series bold 
type
\series default 
 (required): Return type.
 (See Garbage collection 
\begin_inset LatexCommand \ref{sub:lsg-garbage}

\end_inset 

.)
\layout Itemize


\series bold 
qualifier
\series default 
: A qualifier for the method.
 For example "virtual".
\layout Itemize


\series bold 
specifier
\series default 
: A specifier for the method.
 For example "static" or "abstract".
\end_deeper 
\layout Standard

An abstract method must have 
\series bold 
qualifier="virtual"
\series default 
 and 
\series bold 
specifier="abstract"
\series default 
.
 Such a class must have 
\series bold 
abstract="yes"
\series default 
.
 Factory methods 
\begin_inset LatexCommand \ref{sub:lsg-factory}

\end_inset 

 are not generated for abstract classes.
\layout Standard

Parameters of the method may be given as a sequence of <param> elements
 into the <method> element.
 Each <param> has two required attributes - 
\series bold 
name
\series default 
 and 
\series bold 
type
\series default 
.
\layout Itemize

<typedef>: Describes a type definition used in this class.
 It's visibility is public.
 See also Type description 
\begin_inset LatexCommand \ref{sub:lsg-type}

\end_inset 

 below.
\layout Itemize

<enum>: Describes an enumeration type used in this class.
 It's visibility is public.
 See also Enumeration description 
\begin_inset LatexCommand \ref{sub:lsg-enum}

\end_inset 

 below.
\layout Itemize

<visitor>: See Visitors 
\begin_inset LatexCommand \ref{sub:lsg-visitors}

\end_inset 

.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-dataaccess}

\end_inset 

Class data access
\layout Standard

All data members of a generated class are 
\series bold 
protected
\series default 
.
 By default three special methods are generated to realize access to such
 encapsulated fields.
 Visibility of these methods is 
\series bold 
public
\series default 
.
 Each of them may be user-defined or missing.
 For the field 
\series bold 
x
\series default 
 of a type 
\series bold 
T
\series default 
 the methods are:
\layout Itemize


\series bold 
T x_get()
\series default 
 - Returns the value of the field.
\layout Itemize


\series bold 
void x_set(T a)
\series default 
 - Assigns a given value to the field.
\layout Itemize


\series bold 
T x_alt(T a)
\series default 
 - Assigns a new value to the field and returns it.
 (alt as 'alternate')
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-enum}

\end_inset 

Enumeration description
\layout Standard

On the top level or in a class definition, there may occur an <enum> element
 which defines a new enumeration type.
 It has one required attribute 
\series bold 
name
\series default 
 with an identifier of the new type.
 <enum> contains a sequence of <e> elements representing enumerators, each
 of them having a required attribute 
\series bold 
n
\series default 
 (as 'name')
\emph on 
 
\emph default 
with enumerator identifier.
 Optional <e> attribute 
\series bold 
val
\series default 
 associates the enumerator with a constant expression.
 See also an example in the C++ norm 
\series bold 
[7.2/2]
\series default 
.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-type}

\end_inset 

Type description
\layout Standard

On the top level or in a class definition, there may occur a <typedef> element
 which defines a new type.
 It has just two required attributes: 
\series bold 
name
\series default 
 with the new identifier and 
\series bold 
type
\series default 
 with a type specification.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-doxygen}

\end_inset 

Doxygen
\layout Standard


\begin_inset LatexCommand \htmlurl[Doxygen]{http://www.stack.nl/~dimitri/doxygen/}

\end_inset 

 is a program used to generate documentation directly from the source files.
 Hand-written parts of such a documentation are placed into the source files
 as special comments describing the nearby objects.
 Lestes Structures Generator allows users to insert such comments into the
 generated C++ files.
\layout Standard

Almost anywhere in the LSD file, there may occur a <dox> element to add
 a Doxygen-like comment.
 It contains two elements: <bri> with a brief description and <det> with
 a detailed description.
 The <det> element can be omitted, <bri> is required.
 The <dox> element has no attributes (except the top-level <dox>, see LSD
 header part [link]).
\layout LyX-Code

<dox>
\layout LyX-Code

        <bri>Brief comment</bri>
\layout LyX-Code

        <det>Detailed description</det>
\layout LyX-Code

</dox>
\layout Standard

The comment describes the element it occurs in.
 These LSD elements may contain <dox>:
\layout LyX-Code

<typedef/>
\layout LyX-Code

<enum/>
\layout LyX-Code

<class/>
\layout LyX-Code

<field/>
\layout LyX-Code

<collection/>
\layout LyX-Code

<method/>
\layout Standard

The 
\series bold 
method/dox
\series default 
 element should not contain <det> since detailed description of a method
 should be placed near it's implementation (in hand-written .cc file).
\layout Standard

Also the abstract visitor classes written by the LSG may be commented.
 In LVD files the <dox> element may occur in these elements:
\layout LyX-Code

/lvd
\layout LyX-Code

/lvd/visitors/v
\layout LyX-Code

/lvd/visitors/v/special
\layout Standard

It is used the same way as in LSD files.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-garbage}

\end_inset 

Garbage collection
\layout Standard

The C++ language lacks automaticalautomatic garbage collection and forces
 programmers to treat each instance of a class to be deallocated.
 It is however very difficult in a project like Lestes with hundreds of
 different classes and huge heterogeneous data structures.
 It was found that a garbage collector is necessary.
 It's interface and usage is described in Garbage collector [link] chapter.
 Users have to use two types of smart pointers everywhere and to write a
 marking routine for each class.
 The generator strongly helps to realize these two duties.
\layout Subsubsection

Marking routine
\layout Standard

The gc_mark() method is generated fully automatically for all LSD classes
 (including abstract ones).
 The visitor classes generated from LVD files are also made via LSD (see
 Visitors 
\begin_inset LatexCommand \ref{sub:lsg-visitors}

\end_inset 

), so they have their marking routine generated the same way.
\layout Standard

It's visibility is always 
\series bold 
protected
\series default 
 and the prototype is common for all classes:
\layout LyX-Code

virtual void gc_mark();
\layout Standard

The routine simply calls gc_mark() routines of all garbage-collectible members
 specified in this class and of the base class.
 There is no need to touch inherited members.
 And there is no need to iterate through collections of garbage-collectible
 types, since the STL wrappers [link] do it themselves.
\layout Subsubsection

Smart pointers
\layout Standard

The garbage collector forces users to use two kinds of pointers represented
 by 
\series bold 
ptr<T>
\series default 
 and 
\series bold 
srp<T>
\series default 
 templates (both point at a type 
\series bold 
T
\series default 
).
 The 
\series bold 
srp
\series default 
 pointer must be used for members of a structure, class, or collection.
 The 
\series bold 
ptr
\series default 
 pointer everywhere else (return values, local variables, method arguments,
 etc.).
 The generated code obeys these rules.
\layout Subsubsection

Garbage-collectible types
\layout Standard

Garbage-collectible types must be handled by smart pointers, non-collectible
 types are handled by value.
 The rule is that all classes are derived from 
\series bold 
::lestes::std::object
\series default 
 and are garbage-collectible and all simple types are not collectible.
 (A few exceptions exist but has no effect on generator.) The generator tries
 to automatically decide whether an identifier belongs to a class or simple
 type but sometimes it needs a hint.
\layout Standard

The basic assumption is that unknown types are not collected.
 Types like 
\series bold 
lint
\series default 
, 
\series bold 
ucn_string
\series default 
, 
\series bold 
character
\series default 
, etc.
 are not described in any LSD file and the generator doesn't make pointers
 on them.
 The user must let the generator know about each violation of this assumption.
 Note that <include> tags are not used when searching for 
\begin_inset Quotes eld
\end_inset 

known
\begin_inset Quotes erd
\end_inset 

 classes, their purpose is different.
 For classes used in an LSD file (as a base, as a member, as a method argument,
 as a visitor type, or so) but declared somewhere else, there must be one
 of these marks:
\layout LyX-Code

<forward-class name="thomas">
\layout LyX-Code

<using-class name="alva" packages="::lestes::std::"/>
\layout LyX-Code

<foreign-class name="edison">
\layout LyX-Code

       <p>lestes</p>
\layout LyX-Code

       <p>std</p>
\layout LyX-Code

</foreign-class>
\layout Standard

The naming and syntax of these marks has historical reasons and shouldn't
 be taken too seriously.
 May be a subject to change in the future.
\layout Standard

The 
\series bold 
using-class
\series default 
 element declares a class that is used as a base class, as a class member,
 as collection member, as a method parameter, return type, or so.
 If it lies in a different namespace, the attribute 
\series bold 
packages
\series default 
 is filled, otherwise it may be omitted.
 No special C++ text about such a class is generated, except the namespace
 qualification.
 If nothing special is needed, use 
\series bold 
using-class
\series default 
.
\layout Standard

The 
\series bold 
forward-class
\series default 
 element declares a class as 
\series bold 
using-class
\series default 
 does.
 The difference is that 
\series bold 
forward-class
\series default 
 causes a C++ forward declaration to be generated at the beginning of the
 .g.hh file.
 For example:
\layout LyX-Code

class thomas;
\layout Standard

The class must be in the same namespace as the LSD file contents.
\layout Standard

The 
\series bold 
foreign-class
\series default 
 element does the same as 
\series bold 
forward-class
\series default 
 but the class lives in a different namespace.
 The sequence of <p> elements denotes the namespace.
 A forward declaration is generated with respect to the namespace policy
 [link] and it's placed out of the binding 
\series bold 
package/end_package
\series default 
 braces of the generated file.
 Example:
\layout LyX-Code

package(lestes);
\layout LyX-Code

package(std);
\layout LyX-Code

class edison;
\layout LyX-Code

end_package(std);
\layout LyX-Code

end_package(lestes);
\layout Standard

There are some tips about using these tags in the LSD FAQ 
\begin_inset LatexCommand \ref{sub:lsg-faq}

\end_inset 

.
\layout Subsection

Dumping
\layout Standard

LSG inserts some code and data into each class for purposes of the dumper
 [link].
 Static member 
\series bold 
reflection
\series default 
 contains metadata about the class - it's name and it's members names.
 The metadata are created on demand and only once by the 
\series bold 
reflection_get
\series default 
 method.
 The dumper also needs concrete values of the members.
 Method 
\series bold 
field_values_get
\series default 
 returns such list of values.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-instance}

\end_inset 

Creating a class instance
\layout Subsubsection

Constructor
\layout Standard

Each generated class has just one constructor and it's visibility is 
\series bold 
protected
\series default 
.
 It has one argument per each member of the class including inherited ones.
 The values passed to the constructor are used to initialize all the members.
 If some of the data is passed by pointer, the pointer is checked [link]
 for non-null-ness.
 Passing a NULL pointer causes an abnormal program termination.
 The goal is to avoid creation of incomplete classes that could cause bugs
 hard to find.
 But sometimes it can be very annoying.
\layout Subsubsection


\begin_inset LatexCommand \label{sub:lsg-factory}

\end_inset 

Factory method
\layout Standard

Class instances in Lestes are almost every time made by so-called factory
 methods.
 It is a static method called 
\series bold 
create
\series default 
 that allocates and initializes a new instance.
 For the purposes of initialization (see above) the factory method needs
 a value for each member of the class.
 One way to do it is to have one parameter of the factory method for each
 member (as it is by the constructor).
 This case is always enabled, since such a 
\series bold 
create
\series default 
 method is in each generated class that is not abstract.
 But we often don't want to fill all the members by hand when creating an
 object.
 Some fields may have initial values specified in the 
\series bold 
init
\series default 
 attribute.
 In such a case the 
\series bold 
create
\series default 
 method is overloaded and may have a different number of parameters.
 The second one lacks parameters for those fields that have the 
\series bold 
init
\series default 
 attribute specified.
 If each member has an initial value, there will be a 
\series bold 
create
\series default 
 method without parameters.
\layout Subsubsection

A note about the design patterns
\layout Standard

TODO: our factory methods are not 
\emph on 
the true
\emph default 
 factory methods from Design patterns [link].
 describe it here.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-namespaces}

\end_inset 

Namespaces
\layout Standard

The 
\series bold 
package
\series default 
 and 
\series bold 
end_package
\series default 
 macros behaves like left and right braces.
 The main content of an LSD file is placed into one namespace in both the
 .g.hh and .g.cc file.
 Including the contents of 
\series bold 
hh-header
\series default 
, 
\series bold 
hh-footer
\series default 
, 
\series bold 
cc-header
\series default 
, and 
\series bold 
cc-footer
\series default 
 elements.
 A class from a different namespace must be declared with 
\series bold 
using-class
\series default 
 or 
\series bold 
\emph on 
foreign-class
\series default 
\emph default 
 and then the namespace prefix is automatically placed before each occurrence
 of it's identifier.
 For example the 
\series bold 
object
\series default 
 base class should always have a declaration like this.
\layout LyX-Code

<using-class name="object" packages="::lestes::std::"/>
\layout Standard

Only the included files and forward declarations of foreign classes are
 placed outside the main package braces.
 For rationale see our namespace policy [link].
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-visitors}

\end_inset 

Visitors
\layout Subsubsection

Basics
\layout Standard


\series bold 
Visitor
\series default 
 is a design pattern, see Gamma et.
 al [link].
 It's a master peace of object-oriented design in the Lestes project.
 The goal is to separate actions above the complex structure from classes
 that contain the data.
 Visitor is a class representing an action that takes place on classes from
 a specific set.
 The set is determined by a name of one class and it includes the class
 together with all non-abstract classes derived from it.
 Abstract classes cannot be instantiated and therefore cannot be visited.
 The root class has a special note in it's LSD description.
 For example:
\layout LyX-Code

<class name="as_expression" abstract="yes" base="as_base">
\layout LyX-Code

        <!-- some content -->
\layout LyX-Code

        <visitor name="as_expr_visitor" type="void"/>
\layout LyX-Code

</class>
\layout Standard

This defines a visitor class 
\series bold 
as_expr_visitor
\series default 
 that can perform an action on any non-abstract class derived from 
\series bold 
as_expression
\series default 
.
 The class itself is abstract so it cannot be visited.
 The action represented by a visitor has a result of some type.
 In the above example the type is 
\series bold 
void
\series default 
.
\layout Standard

A visitor is used every time when an action implementation depends on the
 class that it's performed on (the 
\series bold 
visitee
\series default 
).
\layout Subsubsection

Abstract and concrete visitors
\layout Standard

The LSG is able to make a visitor class specific for a sub-tree of the class
 hierarchy.
 Such a class is always abstract, because the generator has no information
 about the action implementation.
 And note that there can be more than one action performed on the same set
 of classes.
 It would be nice to have a reusable abstract class to visit a set of classes
 and the concrete visitors (actions) would be derived from it.
 But different actions have different types of results, so we don't know
 what visitor type to specify in the abstract class.
 This is the reason why we have later decided to prefer visitors with return
 type 
\series bold 
void
\series default 
.
 If there is a need to return a value, it can be stored into a special member
 in the concrete visitor class.
\layout Subsubsection

What does the generator produce
\layout Standard

Each class derived from a class with visitor has a generated method with
 such a prototype:
\layout LyX-Code

virtual T accept_V( ptr< V >);
\layout Standard

where 
\series bold 
V
\series default 
 is the visitor's name and 
\series bold 
T
\series default 
 is it's return type.
 If the class is declared as abstract, the 
\series bold 
accept
\series default 
 method is also abstract.
 Otherwise an implementation is generated into the .g.cc file.
 It simply calls corresponding 
\series bold 
visit
\series default 
 method of the visitor class.
\layout Standard

The abstract visitor class is named as specified and it is derived from
 
\series bold 
::lestes::std::visitor_base
\series default 
.
 It contains a public abstract method for each visitee.
 
\layout LyX-Code

virtual T visit_A( ptr< A >) abstract;
\layout Standard

where 
\series bold 
T
\series default 
 is the action result type and 
\series bold 
A
\series default 
 is the visitee.
 The 
\series bold 
visit
\series default 
 method represents an action implementation on a specific class.
\layout Standard

Some other stuff is generated by LSG to make the user's life easier.
 See Implementing visitors 
\begin_inset LatexCommand \ref{sub:lsg-implemvisitors}

\end_inset 

.
\layout Subsubsection

What does the LSG user have to do
\layout Standard

Simply said, the user has to derive his concrete visitor from the generated
 abstract class and implement all the 
\series bold 
visit*
\series default 
 abstract methods.
 If some data storage is needed for the implementation, it can be added
 to the concrete visitor class.
 (For example to store a result or whatever.) To perform the action on a
 given object, instantiate the concrete visitor and call the visitee's 
\series bold 
accept
\series default 
 method with pointer to your visitor.
\layout Standard

Note that the abstract classes are generated into a *.v.lsd file in the LSD
 format (by 
\series bold 
lvd2lsd.xslt
\series default 
 stylesheet).
 This allows users to derive their concrete classes via LSD with all the
 comfort (automatic dump support, marking routines, safe constructors, factory
 methods etc.).
\layout Subsubsection

LVD files
\layout Standard

The abstract visitor classes are generated by a mechanism completely different
 from LSD processing.
 A special XML description of what to do is needed.
 The header part of an LVD file is very similar to LSD except the different
 XML namespace.
\layout LyX-Code

<?xml version="1.0" encoding="UTF-8"?>
\layout LyX-Code

<lvd xmlns="http://lestes.jikos.cz/schemas/lvd">
\layout LyX-Code

        <dox><bri>Some abstract visitor classes</bri></dox>
\layout LyX-Code

        <file-name>zzz</file-name>
\layout LyX-Code

        <imports> .
 .
 .
 </imports>
\layout LyX-Code

        <implementation-imports> .
 .
 .
 </implementation-imports>
\layout LyX-Code

        <packages>
\layout LyX-Code

                <p>foo</p>
\layout LyX-Code

                <p>bar</p>
\layout LyX-Code

        </packages>
\layout LyX-Code

        <hh-header/>
\layout LyX-Code

        <hh-footer/>
\layout Standard

A sequence of <uses> elements follow such a header.
 The element has a 
\series bold 
href
\series default 
 attribute with a path to an LSD file, where some visitees are defined.
 The main part is in the <visitors> element that simply specifies names
 of the visitors.
\layout LyX-Code

<visitors>
\layout LyX-Code

        <v name="quo"/>
\layout LyX-Code

        <v name="vadis"/>
\layout LyX-Code

        <v name="domine"/>
\layout LyX-Code

</visitors>
\layout Standard

All other necessary information is automatically searched in the LSD files
 via <uses>.
 Usage of Doxygen comments is described in the above section 
\begin_inset LatexCommand \ref{sub:lsg-doxygen}

\end_inset 

.
 Instructions for <import> are in LSD FAQ 
\begin_inset LatexCommand \ref{sub:lsg-faq}

\end_inset 

.
\layout Standard

Note: Do not accumulate all visitors into one LVD file to avoid include
 hell.
 4 of 5 Lestes developers recomend: One algorithm, one file with visitors.
\layout Subsubsection


\begin_inset LatexCommand \label{sub:lsg-implemvisitors}

\end_inset 

Implementing visitors - the inheritance tree cuts
\layout Standard

Some visitors may visit a lot of classes.
 In practise, the action implementation is often the same for many of them
 and it would be annoying to write all the 
\series bold 
visit
\series default 
 methods by hand.
 Any small change in implementation would force user to type it repeatedly
 - a possible source of bugs.
 So which classes do have the same implementation?
\layout Standard

Let's watch a 
\begin_inset LatexCommand \htmlurl[real-life example]{http://lestes.jikos.cz/html/classlestes_1_1lang_1_1cplus_1_1sem_1_1ss__type.html}

\end_inset 

.
 Class 
\series bold 
ss_type_visitor
\series default 
 is an abstract visitor for 
\series bold 
ss_type
\series default 
 descendants.
 The action depends on a specific class.
 It is different for 
\series bold 
ss_array
\series default 
, 
\series bold 
ss_enum
\series default 
, 
\series bold 
ss_function
\series default 
, 
\series bold 
ss_builtin_type
\series default 
, 
\series bold 
ss_struct_base
\series default 
, and so on.
 But it doesn't depend on a concrete builtin type (15 different non-abstract
 classes!).
 And it's also the same for all descendants of 
\series bold 
ss_struct_base
\series default 
.
 We would therefore like to implement it just once for all 
\series bold 
ss_builtin_type
\series default 
 descendants.
 And the second time for 
\series bold 
ss_struct_base
\series default 
 descendants.
 The LSG offers such a feature.
\layout LyX-Code

<v name="ss_type_visitor" >
\layout LyX-Code

        <special name="ss_type2info_base">
\layout LyX-Code

                <cut at="ss_struct_base" method="process_ss_struct_base"/>
\layout LyX-Code

                <cut at="ss_builtin_type" method="process_ss_builtin_type"/>
\layout LyX-Code

        </special>
\layout LyX-Code

</v>
\layout Standard

In this example the LSG will generate an abstract class 
\series bold 
ss_type_visitor
\series default 
 as usually.
 In addition, there will be a class 
\series bold 
ss_type2info_base
\series default 
 derived from 
\series bold 
ss_type_visitor
\series default 
.
 All its 
\series bold 
visit
\series default 
 methods for 
\series bold 
ss_builtin_type
\series default 
 descendants are automatically implemented as a call to a 
\series bold 
process_ss_builtin_base
\series default 
 method.
 For descendants of 
\series bold 
ss_struct_base
\series default 
 the method 
\series bold 
process_ss_struct_base
\series default 
 is called.
 Both 
\series bold 
process*
\series default 
 methods are automatically added as abstract, since the generator desn't
 know about the true action.
 Therefore the class 
\series bold 
ss_type2info_base
\series default 
 is also abstract.
 The concrete visior is derived from it and implements the two 
\series bold 
process*
\series default 
 methods and all the 
\series bold 
visit*
\series default 
 methods that remain.
 Such a concrete visitor is 
\series bold 
ss_type2info
\series default 
.
 Its hand-written implementation is in 
\series bold 
ss_type2info.cc
\series default 
 file and it contains just one method for each nearest descendant of 
\series bold 
ss_type
\series default 
, all in all 13 methods.
 That was our goal.
 Note that
\series bold 
 ss_type2info
\series default 
 visits 28 non-abstract classes.
 And note that there is no problem to have more than one <special> in a
 specific abstract visitor.
\layout Standard

One additional feature of the generator is used in the above example and
 not yet mentioned.
 If a class implements some inherited abstract methods, C++ requires explicit
 declaration of all such methods in the class declaration (header file).
 It's easy to accidentaly omit one of the declarations.
 Then the class remains abstract and the compilation fails at it's instantiation.
 In the worse case some declaration may be extra and there remains an extra
 implementation that is never called.
 Both these problems may be prevented using automatic generation of the
 declarations.
 Note that the class 
\series bold 
ss_type2info
\series default 
 has a special line in it's LSD definition.
\layout LyX-Code

<declare-abstract-methods prefix="visit_" skip-defined="yes" />
\layout Standard

It generates declarations of all abstract methods in the class that start
 with 
\series bold 
visit_
\series default 
 prefix.
 Instead of the prefix a suffix may be specified with 
\series bold 
suffix=
\begin_inset Quotes erd
\end_inset 

fff
\begin_inset Quotes erd
\end_inset 


\series default 
 or an exact match may be required with 
\series bold 
exact=
\begin_inset Quotes erd
\end_inset 

identifier
\begin_inset Quotes erd
\end_inset 


\series default 
.
 The 
\series bold 
skip-defined
\series default 
 attribute may be optionally used to skip the methods that have been defined
 previously.
 Omitting all of these attributes causes all abstract methods to be declared
 and forced to be implemented.
\layout Subsection


\begin_inset LatexCommand \label{sub:lsg-faq}

\end_inset 

LSD frequently asked questions
\layout Subsubsection

Using-class or a forward declaration?
\layout Standard

In most cases the forward declaration is not necessary and the 
\series bold 
using-class
\series default 
 element is enough to let the generator know about the class.
 When do we really need a forward declaration?
\layout Itemize

For each visitor class.
\layout Itemize

When 
\series bold 
alice.lsd
\series default 
 uses a class 
\series bold 
photon
\series default 
 defined in 
\series bold 
bob.lsd
\series default 
, but 
\series bold 
bob.lsd
\series default 
 also uses some classes from 
\series bold 
alice.lsd
\series default 
 and therefore
\emph on 
 
\emph default 
needs to import 
\series bold 
alice.g.hh
\series default 
.
\layout Itemize

?
\layout Subsubsection

Import or implementation-import?
\layout Standard

In many cases the 
\series bold 
import
\series default 
 isn't necessary and only 
\series bold 
implementation-import
\series default 
 should be used to avoid include hell.
 But sometimes you need to see the whole declaration of a class in the .g.hh
 file.
\layout Itemize

The basic rule is that you need to <import> all classes used as bases.
 <implementation-import> should be enough for everything else.
\layout Itemize

When gcc gives you a strange 
\begin_inset Quotes eld
\end_inset 

invalid static cast
\begin_inset Quotes erd
\end_inset 

 error in the ptr.hh file, it is most likely that the class declaration isn't
 visible in the .g.hh.
 file.
 <implementation-import> of an appropriate header should fix it.
\the_end
